Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.4.6.18
retrieving revision 1.4.6.19
diff -u -r1.4.6.18 -r1.4.6.19
--- squid/src/acl.c	1 Jul 2007 08:34:23 -0000	1.4.6.18
+++ squid/src/acl.c	2 Jul 2007 07:36:51 -0000	1.4.6.19
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.4.6.18 2007/07/01 08:34:23 amosjeffries Exp $
+ * $Id: acl.c,v 1.4.6.19 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -53,18 +53,18 @@
 static int aclMatchAcl(struct _acl *, aclCheck_t *);
 static int aclMatchTime(acl_time_data * data, time_t when);
 static int aclMatchUser(void *proxyauth_acl, char *user);
-static int aclMatchIp(void *dataptr, struct sockaddr *c);
+static int aclMatchIp(void *dataptr, struct in_addr c);
 static int aclMatchDomainList(void *dataptr, const char *);
 static int aclMatchIntegerRange(intrange * data, int i);
 static int aclMatchWordList(wordlist *, const char *);
 static void aclParseUserMaxIP(void *data);
 static void aclDestroyUserMaxIP(void *data);
 static wordlist *aclDumpUserMaxIP(void *data);
-static int aclMatchUserMaxIP(void *, auth_user_request_t *, struct sockaddr *);
+static int aclMatchUserMaxIP(void *, auth_user_request_t *, struct in_addr);
 static void aclParseHeader(void *data);
 static void aclDestroyHeader(void *data);
 static squid_acl aclStrToType(const char *s);
-static int decode_addr(const char *, struct sockaddr *);
+static int decode_addr(const char *, struct in_addr *);
 static void aclCheck(aclCheck_t * checklist);
 static void aclCheckCallback(aclCheck_t * checklist, allow_t answer);
 #if USE_IDENT
@@ -431,31 +431,35 @@
  * This function should NOT be called if 'asc' is a hostname!
  */
 static int
-decode_addr(const char *asc, struct sockaddr *addr)
+decode_addr(const char *asc, struct in_addr *addr)
 {
-    struct addrinfo hints, *res;
-    int error;
+    int a1 = 0, a2 = 0, a3 = 0, a4 = 0;
 
-    memset(&hints, 0, sizeof(hints));
-    hints.ai_family = PF_UNSPEC;
-    hints.ai_flags = AI_NUMERICHOST|AI_PASSIVE;
-
-    error = getaddrinfo(asc, NULL, &hints, &res);
-    if (error) {
+    switch (sscanf(asc, "%d.%d.%d.%d", &a1, &a2, &a3, &a4)) {
+    case 4:			/* a dotted quad */
+	if (!safe_inet_addr(asc, addr)) {
+	    debug(28, 0) ("decode_addr: unsafe IP address: '%s'\n", asc);
+	    self_destruct();
+	}
+	break;
+    case 1:			/* a significant bits value for a mask */
+	if (a1 >= 0 && a1 < 33) {
+	    addr->s_addr = a1 ? htonl(0xfffffffful << (32 - a1)) : 0;
+	    break;
+	}
+    default:
 	debug(28, 0) ("decode_addr: Invalid IP address '%s'\n", asc);
 	return 0;		/* This is not valid address */
     }
-    xmemcpy(addr, res->ai_addr, SOCKLEN(res->ai_addr));
-    freeaddrinfo(res);
 
     return 1;
 }
 
 
-#define SCAN_ACL1       "%[0123456789abcdef:.]-%[0123456789abcdef:.]/%[0123456789]"
-#define SCAN_ACL2       "%[0123456789abcdef:.]-%[0123456789abcdef:.]%c"
-#define SCAN_ACL3       "%[0123456789abcdef:.]/%[0123456789]"
-#define SCAN_ACL4       "%[0123456789abcdef:.]%c"
+#define SCAN_ACL1       "%[0123456789.]-%[0123456789.]/%[0123456789.]"
+#define SCAN_ACL2       "%[0123456789.]-%[0123456789.]%c"
+#define SCAN_ACL3       "%[0123456789.]/%[0123456789.]"
+#define SCAN_ACL4       "%[0123456789.]%c"
 
 static acl_ip_data *
 aclParseIpData(const char *t)
@@ -464,14 +468,19 @@
     LOCAL_ARRAY(char, addr2, 256);
     LOCAL_ARRAY(char, mask, 256);
     acl_ip_data *q = memAllocate(MEM_ACL_IP_DATA);
+    acl_ip_data *r;
+    acl_ip_data **Q;
+    struct hostent *hp;
+    char **x;
     char c;
     debug(28, 5) ("aclParseIpData: %s\n", t);
     if (!strcasecmp(t, "all")) {
-	q->addr1.ss_family = 0;
-	q->addr2.ss_family = 0;
-	q->masklen = 0;
+	q->addr1.s_addr = 0;
+	q->addr2.s_addr = 0;
+	q->mask.s_addr = 0;
 	return q;
     }
+    q->mask.s_addr = no_addr.s_addr;	/* 255.255.255.255 */
     if (sscanf(t, SCAN_ACL1, addr1, addr2, mask) == 3) {
 	(void) 0;
     } else if (sscanf(t, SCAN_ACL2, addr1, addr2, &c) == 2) {
@@ -480,21 +489,29 @@
 	addr2[0] = '\0';
     } else if (sscanf(t, SCAN_ACL4, addr1, &c) == 1) {
 	addr2[0] = '\0';
-	strcpy(mask, "-1");
+	mask[0] = '\0';
     } else if (sscanf(t, "%[^/]/%s", addr1, mask) == 2) {
 	addr2[0] = '\0';
     } else if (sscanf(t, "%s", addr1) == 1) {
-	struct addrinfo hints, *res;
-	memset(&hints, '\0', sizeof(hints));
-	hints.ai_family = PF_UNSPEC;
-	if (getaddrinfo(t, NULL, &hints, &res)) {
+	/*
+	 * Note, must use plain gethostbyname() here because at startup
+	 * ipcache hasn't been initialized
+	 */
+	if ((hp = gethostbyname(addr1)) == NULL) {
 	    debug(28, 0) ("aclParseIpData: Bad host/IP: '%s'\n", t);
 	    safe_free(q);
 	    return NULL;
 	}
-	xmemcpy(&q->addr1, res->ai_addr, res->ai_addrlen);
-	q->masklen = (res->ai_family == AF_INET6) ? 128 : 32;
-	freeaddrinfo(res);
+	Q = &q;
+	for (x = hp->h_addr_list; x != NULL && *x != NULL; x++) {
+	    if ((r = *Q) == NULL)
+		r = *Q = memAllocate(MEM_ACL_IP_DATA);
+	    xmemcpy(&r->addr1.s_addr, *x, sizeof(r->addr1.s_addr));
+	    r->addr2.s_addr = 0;
+	    r->mask.s_addr = no_addr.s_addr;	/* 255.255.255.255 */
+	    Q = &r->next;
+	    debug(28, 3) ("%s --> %s\n", addr1, inet_ntoa(r->addr1));
+	}
 	return q;
     } else {
 	debug(28, 0) ("aclParseIpData: Bad host/IP: '%s'\n", t);
@@ -502,7 +519,7 @@
 	return NULL;
     }
     /* Decode addr1 */
-    if (!decode_addr(addr1, (struct sockaddr *)&q->addr1)) {
+    if (!decode_addr(addr1, &q->addr1)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
 	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown first address '%s'\n", addr1);
@@ -510,7 +527,7 @@
 	return NULL;
     }
     /* Decode addr2 */
-    if (*addr2 && !decode_addr(addr2, (struct sockaddr *)&q->addr2)) {
+    if (*addr2 && !decode_addr(addr2, &q->addr2)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
 	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown second address '%s'\n", addr2);
@@ -518,30 +535,19 @@
 	return NULL;
     }
     /* Decode mask */
-    if (*mask) {
-	q->masklen = atoi(mask);
-	switch (q->addr1.ss_family) {
-	case AF_INET:
-	    if (q->masklen == -1)
-		q->masklen = 32;
-	    if (q->masklen > 32)
-		q->masklen = -1;
-	    break;
-	case AF_INET6:
-	    if (q->masklen == -1)
-		q->masklen = 128;
-	    if (q->masklen > 128)
-		q->masklen = -1;
-	    break;
-	}
-	if (*mask && (q->masklen == -1)) {
-	    debug(28, 0) ("%s line %d: %s\n",
+    if (*mask && !decode_addr(mask, &q->mask)) {
+	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	    debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown masklen'%s'\n", mask);
-	    safe_free(q);
-	    return NULL;
-	}
+	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown netmask '%s'\n", mask);
+	safe_free(q);
+	return NULL;
     }
+    if ((q->addr1.s_addr & q->mask.s_addr) != q->addr1.s_addr ||
+	(q->addr2.s_addr & q->mask.s_addr) != q->addr2.s_addr)
+	debug(28, 0) ("aclParseIpData: WARNING: Netmask masks away part of the specified IP in '%s'\n", t);
+    q->addr1.s_addr &= q->mask.s_addr;
+    q->addr2.s_addr &= q->mask.s_addr;
+    /* 1.2.3.4/255.255.255.0  --> 1.2.3.0 */
     return q;
 }
 
@@ -1289,7 +1295,7 @@
 /**************/
 
 static int
-aclMatchIp(void *dataptr, struct sockaddr *c)
+aclMatchIp(void *dataptr, struct in_addr c)
 {
     splayNode **Top = dataptr;
     acl_ip_data x;
@@ -1302,12 +1308,13 @@
      * XXX Could eliminate these repetitive assignments with a
      * static structure.
      */
-    xmemcpy(&x.addr1, c, SOCKLEN(c));
-    x.masklen = 0;
+    x.addr1 = c;
+    x.addr2 = any_addr;
+    x.mask = no_addr;
     x.next = NULL;
     *Top = splay_splay(&x, *Top, aclIpAddrNetworkCompare);
     debug(28, 3) ("aclMatchIp: '%s' %s\n",
-	sockaddr_ntoa(c), splayLastResult ? "NOT found" : "found");
+	inet_ntoa(c), splayLastResult ? "NOT found" : "found");
     return !splayLastResult;
 }
 
@@ -1542,7 +1549,7 @@
  */
 int
 aclMatchUserMaxIP(void *data, auth_user_request_t * auth_user_request,
-    struct sockaddr *src_addr)
+    struct in_addr src_addr)
 {
 /*
  * the logic for flush the ip list when the limit is hit vs keep
@@ -1707,7 +1714,7 @@
     }
     /* get authed here */
     /* Note: this fills in checklist->auth_user_request when applicable (auth incomplete) */
-    switch (authenticateTryToAuthenticateAndSetAuthUser(&checklist->auth_user_request, headertype, checklist->request, checklist->conn, (struct sockaddr *)&checklist->src_addr)) {
+    switch (authenticateTryToAuthenticateAndSetAuthUser(&checklist->auth_user_request, headertype, checklist->request, checklist->conn, checklist->src_addr)) {
     case AUTH_ACL_CANNOT_AUTHENTICATE:
 	debug(28, 4) ("aclMatchAcl: returning  0 user authenticated but not authorised.\n");
 	return 0;
@@ -1778,16 +1785,16 @@
     debug(28, 3) ("aclMatchAcl: checking '%s'\n", ae->cfgline);
     switch (ae->type) {
     case ACL_SRC_IP:
-	return aclMatchIp(&ae->data, (struct sockaddr *)&checklist->src_addr);
+	return aclMatchIp(&ae->data, checklist->src_addr);
 	/* NOTREACHED */
     case ACL_MY_IP:
-	return aclMatchIp(&ae->data, (struct sockaddr *)&checklist->my_addr);
+	return aclMatchIp(&ae->data, checklist->my_addr);
 	/* NOTREACHED */
     case ACL_DST_IP:
 	ia = ipcache_gethostbyname(r->host, IP_LOOKUP_IF_MISS);
 	if (ia) {
 	    for (k = 0; k < (int) ia->count; k++) {
-		if (aclMatchIp(&ae->data, (struct sockaddr *)&ia->in_addrs[k]))
+		if (aclMatchIp(&ae->data, ia->in_addrs[k]))
 		    return 1;
 	    }
 	    return 0;
@@ -1805,24 +1812,24 @@
 	    return 1;
 	if ((ia = ipcacheCheckNumeric(r->host)) == NULL)
 	    return 0;
-	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr(ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
 	if (fqdn)
 	    return aclMatchDomainList(&ae->data, fqdn);
 	if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, sockaddr_ntoa(&ia->in_addrs[0])); 
+		ae->name, inet_ntoa(ia->in_addrs[0]));
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
 	return aclMatchDomainList(&ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOMAIN:
-	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchDomainList(&ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, ""); /*XXX inet_ntoa(checklist->src_addr)); */
+		ae->name, inet_ntoa(checklist->src_addr));
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
@@ -1833,24 +1840,24 @@
 	    return 1;
 	if ((ia = ipcacheCheckNumeric(r->host)) == NULL)
 	    return 0;
-	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr(ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
 	if (fqdn)
 	    return aclMatchRegex(ae->data, fqdn);
 	if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, sockaddr_ntoa(&ia->in_addrs[0])); 
+		ae->name, inet_ntoa(ia->in_addrs[0]));
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
 	return aclMatchRegex(ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOM_REGEX:
-	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchRegex(ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, sockaddr_ntoa(&checklist->src_addr));
+		ae->name, inet_ntoa(checklist->src_addr));
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
@@ -1880,7 +1887,7 @@
 	return k;
 	/* NOTREACHED */
     case ACL_MAXCONN:
-	k = clientdbEstablished((struct sockaddr *)&checklist->src_addr, 0);
+	k = clientdbEstablished(checklist->src_addr, 0);
 	return ((k > ((intlist *) ae->data)->i) ? 1 : 0);
 	/* NOTREACHED */
     case ACL_URL_PORT:
@@ -1943,7 +1950,7 @@
 	if ((ti = aclAuthenticated(checklist)) != 1)
 	    return ti;
 	ti = aclMatchUserMaxIP(ae->data, r->auth_user_request,
-	    (struct sockaddr *)&checklist->src_addr);
+	    checklist->src_addr);
 	return ti;
 	/* NOTREACHED */
 #if SQUID_SNMP
@@ -1952,13 +1959,13 @@
 	/* NOTREACHED */
 #endif
     case ACL_SRC_ASN:
-	return asnMatchIp(ae->data, (struct sockaddr *)&checklist->src_addr);
+	return asnMatchIp(ae->data, checklist->src_addr);
 	/* NOTREACHED */
     case ACL_DST_ASN:
 	ia = ipcache_gethostbyname(r->host, IP_LOOKUP_IF_MISS);
 	if (ia) {
 	    for (k = 0; k < (int) ia->count; k++) {
-		if (asnMatchIp(ae->data, (struct sockaddr *)&ia->in_addrs[k]))
+		if (asnMatchIp(ae->data, ia->in_addrs[k]))
 		    return 1;
 	    }
 	    return 0;
@@ -1967,13 +1974,13 @@
 		ae->name, r->host);
 	    checklist->state[ACL_DST_ASN] = ACL_LOOKUP_NEEDED;
 	} else {
-	    return asnMatchIp(ae->data, (struct sockaddr *)&no_addr);
+	    return asnMatchIp(ae->data, no_addr);
 	}
 	return 0;
 	/* NOTREACHED */
 #if USE_ARP_ACL
     case ACL_SRC_ARP:
-	return aclMatchArp(&ae->data, (struct sockaddr *)&checklist->src_addr);
+	return aclMatchArp(&ae->data, checklist->src_addr);
 	/* NOTREACHED */
 #endif
     case ACL_REQ_MIME_TYPE:
@@ -2169,7 +2176,7 @@
 	    return;
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NEEDED) {
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_PENDING;
-	    fqdncache_nbgethostbyaddr((struct sockaddr *)&checklist->src_addr,
+	    fqdncache_nbgethostbyaddr(checklist->src_addr,
 		aclLookupSrcFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NEEDED) {
@@ -2180,7 +2187,7 @@
 	    }
 	    checklist->dst_addr = ia->in_addrs[0];
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_PENDING;
-	    fqdncache_nbgethostbyaddr((struct sockaddr *)&checklist->dst_addr,
+	    fqdncache_nbgethostbyaddr(checklist->dst_addr,
 		aclLookupDstFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_PROXY_AUTH] == ACL_LOOKUP_NEEDED) {
@@ -2202,7 +2209,7 @@
 	else if (checklist->state[ACL_IDENT] == ACL_LOOKUP_NEEDED) {
 	    debug(28, 3) ("aclCheck: Doing ident lookup\n");
 	    if (cbdataValid(checklist->conn)) {
-		identStart((struct sockaddr *)&checklist->conn->me, (struct sockaddr *)&checklist->conn->peer,
+		identStart(&checklist->conn->me, &checklist->conn->peer,
 		    aclLookupIdentDone, checklist);
 		checklist->state[ACL_IDENT] = ACL_LOOKUP_PENDING;
 		return;
@@ -2374,17 +2381,7 @@
 aclChecklistCacheInit(aclCheck_t * checklist)
 {
     request_t *request = checklist->request;
-    struct sockaddr *A = (struct sockaddr*)&checklist->src_addr;
-    if( request != NULL && 
-        (
-          ( (checklist->src_addr.ss_family == AF_INET6)
-           && IN6_IS_ADDR_UNSPECIFIED( &((struct sockaddr_in6 *)A)->sin6_addr )
-          ) ||
-          ( (checklist->src_addr.ss_family == AF_INET)
-            && (((struct sockaddr_in *)A)->sin_addr.s_addr == 0)
-          )
-        )
-    ) {
+    if (request != NULL && checklist->src_addr.s_addr == 0) {
 #if FOLLOW_X_FORWARDED_FOR
 	if (Config.onoff.acl_uses_indirect_client) {
 	    checklist->src_addr = request->indirect_client_addr;
@@ -2696,7 +2693,19 @@
 static void
 aclIpDataToStr(const acl_ip_data * ip, char *buf, int len)
 {
-    snprintf(buf, len, "%s/%d", sockaddr_ntoa(&ip->addr1), ip->masklen);
+    char b1[20];
+    char b2[20];
+    char b3[20];
+    snprintf(b1, 20, "%s", inet_ntoa(ip->addr1));
+    if (ip->addr2.s_addr != any_addr.s_addr)
+	snprintf(b2, 20, "-%s", inet_ntoa(ip->addr2));
+    else
+	b2[0] = '\0';
+    if (ip->mask.s_addr != no_addr.s_addr)
+	snprintf(b3, 20, "/%s", inet_ntoa(ip->mask));
+    else
+	b3[0] = '\0';
+    snprintf(buf, len, "%s%s%s", b1, b2, b3);
 }
 
 /*
@@ -2709,77 +2718,27 @@
 static int
 aclIpNetworkCompare2(const acl_ip_data * p, const acl_ip_data * q)
 {
-    if (q->addr1.ss_family < p->addr1.ss_family)
-	return -1;
-    else 
-    if (q->addr1.ss_family > p->addr1.ss_family)
-	return 1;
-    else
-    if (q->addr1.ss_family == AF_INET) {
-	u_int32_t maskedup_B; 
-	u_int32_t A = ntohl(((struct sockaddr_in *)&p->addr1)->sin_addr.s_addr);
-	u_int32_t B = ntohl(((struct sockaddr_in *)&q->addr1)->sin_addr.s_addr);
-
-	if (q->masklen == 0)
-	    return 0;
-
-	maskedup_B = ((B >> (32 - q->masklen)) + 1) << (32 - q->masklen);
-	maskedup_B--;
-
-	if (A < B)
-	    return -1;
-	else if (A > maskedup_B)
-	    return 1;
+    struct in_addr A = p->addr1;
+    const struct in_addr B = q->addr1;
+    const struct in_addr C = q->addr2;
+    int rc = 0;
+    A.s_addr &= q->mask.s_addr;	/* apply netmask */
+    if (C.s_addr == 0) {	/* single address check */
+	if (ntohl(A.s_addr) > ntohl(B.s_addr))
+	    rc = 1;
+	else if (ntohl(A.s_addr) < ntohl(B.s_addr))
+	    rc = -1;
 	else
-	    return 0;
-    }
-    else
-    if (q->addr1.ss_family == AF_INET6) {
-
-	int masklen, invmasklen, i, rc;
-	struct in6_addr A, B;
-
-	if (q->masklen == 0)
-	    return 0;
-
-	xmemcpy(&A, &((struct sockaddr_in6 *)&p->addr1)->sin6_addr, sizeof(struct in6_addr));
-	xmemcpy(&B, &((struct sockaddr_in6 *)&q->addr1)->sin6_addr, sizeof(struct in6_addr));
-
-	invmasklen = 128 - q->masklen;
-	masklen = q->masklen;
-
- 	rc = 0;
-	for (i = 0; i < 16; i=i+4) {
-	    if (masklen >= 32) {
-		if (IN6_NTOHL_N(&A, i) < IN6_NTOHL_N(&B, i))
-		    return -1;
-		else
-		if (IN6_NTOHL_N(&A, i) > IN6_NTOHL_N(&B, i))
-		    return 1;
-		else
-		    masklen = masklen - 32;
-	    }
-	    else if (masklen > 0) {
-		invmasklen = 32 - masklen;
-		debug(28, 3) ("aclIpNetworkCompare2: %s vs %s,\n",
-			sockaddr_ntoa(&p->addr1), sockaddr_ntoa(&q->addr1));
-    		debug(28, 3) ("aclIpNetworkCompare2: %x/%d (%x) vs %x\n",
-			IN6_NTOHL_N(&A, i), masklen,
-			IN6_NTOHL_N(&A, i) & (0xffffffff << invmasklen), 
-			IN6_NTOHL_N(&B, i));
-		if (IN6_NTOHL_N(&A, i) < IN6_NTOHL_N(&B, i))
-		    return -1;
-		else
-		if ((IN6_NTOHL_N(&A, i) & (0xffffffff << invmasklen)) > IN6_NTOHL_N(&B, i))
-		    return 1;
-		else
-		    return 0;
-	    }
-	}
+	    rc = 0;
+    } else {			/* range address check */
+	if (ntohl(A.s_addr) > ntohl(C.s_addr))
+	    rc = 1;
+	else if (ntohl(A.s_addr) < ntohl(B.s_addr))
+	    rc = -1;
+	else
+	    rc = 0;
     }
-    else
-	return 0;
-    return 0;
+    return rc;
 }
 
 /*
@@ -2803,14 +2762,16 @@
 	ret = aclIpNetworkCompare2(n1, n2);
     }
     if (ret == 0) {
-	char buf_n1[100];
-	char buf_n2[100];
-	getnameinfo((struct sockaddr *)&n1->addr1, SOCKLEN(&n1->addr1), buf_n1, 100, NULL, 0, NI_NUMERICHOST);
-	getnameinfo((struct sockaddr *)&n2->addr1, SOCKLEN(&n2->addr1), buf_n2, 100, NULL, 0, NI_NUMERICHOST);
+	char buf_n1[60];
+	char buf_n2[60];
+	char buf_a[60];
+	aclIpDataToStr(n1, buf_n1, 60);
+	aclIpDataToStr(n2, buf_n2, 60);
+	aclIpDataToStr((acl_ip_data *) a, buf_a, 60);
 	debug(28, 0) ("WARNING: '%s' is a subnetwork of "
 	    "'%s'\n", buf_n1, buf_n2);
 	debug(28, 0) ("WARNING: because of this '%s' is ignored "
-	    "to keep splay tree searching predictable\n", buf_n1);
+	    "to keep splay tree searching predictable\n", buf_a);
 	debug(28, 0) ("WARNING: You should probably remove '%s' "
 	    "from the ACL named '%s'\n", buf_n1, AclMatchedName);
     }
@@ -2861,12 +2822,11 @@
     MemBuf mb;
     wordlist **W = state;
     memBufDefInit(&mb);
-    memBufPrintf(&mb, "%s", sockaddr_ntoa(&ip->addr1));
-/*
+    memBufPrintf(&mb, "%s", inet_ntoa(ip->addr1));
     if (ip->addr2.s_addr != any_addr.s_addr)
-	memBufPrintf(&mb, "-%s", sockaddr_ntoa(&ip->addr2));
-*/
-    memBufPrintf(&mb, "/%d", ip->masklen);
+	memBufPrintf(&mb, "-%s", inet_ntoa(ip->addr2));
+    if (ip->mask.s_addr != no_addr.s_addr)
+	memBufPrintf(&mb, "/%s", inet_ntoa(ip->mask));
     wordlistAdd(W, mb.buf);
     memBufClean(&mb);
 }
@@ -3273,7 +3233,7 @@
 	/* Do lookup */
 	*Top = splay_splay(&arpReq.arp_ha.sa_data, *Top, aclArpCompare);
 	debug(28, 3) ("aclMatchArp: '%s' %s\n",
-	    sockaddr_ntoa(c), splayLastResult ? "NOT found" : "found");
+	    inet_ntoa(c), splayLastResult ? "NOT found" : "found");
 	return (0 == splayLastResult);
     }
     /* lookup list of interface names */
Index: squid/src/asn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/asn.c,v
retrieving revision 1.4.4.7
retrieving revision 1.4.4.8
diff -u -r1.4.4.7 -r1.4.4.8
--- squid/src/asn.c	1 Jul 2007 05:44:18 -0000	1.4.4.7
+++ squid/src/asn.c	2 Jul 2007 07:36:52 -0000	1.4.4.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: asn.c,v 1.4.4.7 2007/07/01 05:44:18 amosjeffries Exp $
+ * $Id: asn.c,v 1.4.4.8 2007/07/02 07:36:52 amosjeffries Exp $
  *
  * DEBUG: section 53    AS Number handling
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -103,7 +103,7 @@
 /* PUBLIC */
 
 int
-asnMatchIp(void *data, struct sockaddr *saddr)
+asnMatchIp(void *data, struct in_addr addr)
 {
     unsigned long lh;
     struct squid_radix_node *rn;
@@ -111,10 +111,6 @@
     m_int m_addr;
     intlist *a = NULL;
     intlist *b = NULL;
-    struct in_addr addr = ((struct sockaddr_in *)saddr)->sin_addr;
-
-    if (saddr->sa_family == AF_INET6)
-	return 1;
     lh = ntohl(addr.s_addr);
     debug(53, 3) ("asnMatchIp: Called for %s.\n", inet_ntoa(addr));
 
Index: squid/src/authenticate.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/authenticate.c,v
retrieving revision 1.4.6.10
retrieving revision 1.4.6.11
diff -u -r1.4.6.10 -r1.4.6.11
--- squid/src/authenticate.c	1 Jul 2007 05:44:18 -0000	1.4.6.10
+++ squid/src/authenticate.c	2 Jul 2007 07:36:52 -0000	1.4.6.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: authenticate.c,v 1.4.6.10 2007/07/01 05:44:18 amosjeffries Exp $
+ * $Id: authenticate.c,v 1.4.6.11 2007/07/02 07:36:52 amosjeffries Exp $
  *
  * DEBUG: section 29    Authenticator
  * AUTHOR: Duane Wessels
@@ -43,7 +43,7 @@
 CBDATA_TYPE(auth_user_ip_t);
 
 static void authenticateDecodeAuth(const char *proxy_auth, auth_user_request_t * auth_user_request);
-static auth_acl_t authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr);
+static auth_acl_t authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr);
 
 /*
  *
@@ -259,10 +259,11 @@
 }
 
 static void
-authenticateAuthUserRequestSetIp(auth_user_request_t * auth_user_request, struct sockaddr *ipaddr)
+authenticateAuthUserRequestSetIp(auth_user_request_t * auth_user_request, struct in_addr ipaddr)
 {
     auth_user_ip_t *ipdata, *next;
     auth_user_t *auth_user;
+    char *ip1;
     int found = 0;
     CBDATA_INIT_TYPE(auth_user_ip_t);
     if (!auth_user_request->auth_user)
@@ -277,7 +278,7 @@
     while ((ipdata = next) != NULL) {
 	next = (auth_user_ip_t *) ipdata->node.next;
 	/* walk the ip list */
-	if (!memcmp(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr))) {
+	if (ipdata->ipaddr.s_addr == ipaddr.s_addr) {
 	    /* This ip has already been seen. */
 	    found = 1;
 	    /* update IP ttl */
@@ -294,15 +295,17 @@
     /* This ip is not in the seen list */
     ipdata = cbdataAlloc(auth_user_ip_t);
     ipdata->ip_expiretime = squid_curtime;
-    xmemcpy(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr));
+    ipdata->ipaddr = ipaddr;
     dlinkAddTail(ipdata, &ipdata->node, &auth_user->ip_list);
     auth_user->ipcount++;
 
-    debug(29, 2) ("authenticateAuthUserRequestSetIp: user '%s' has been seen at a new IP address (%s)\n", authenticateUserUsername(auth_user), sockaddr_ntoa(ipaddr));
+    ip1 = xstrdup(inet_ntoa(ipaddr));
+    debug(29, 2) ("authenticateAuthUserRequestSetIp: user '%s' has been seen at a new IP address (%s)\n", authenticateUserUsername(auth_user), ip1);
+    safe_free(ip1);
 }
 
 void
-authenticateAuthUserRequestRemoveIp(auth_user_request_t * auth_user_request, struct sockaddr *ipaddr)
+authenticateAuthUserRequestRemoveIp(auth_user_request_t * auth_user_request, struct in_addr ipaddr)
 {
     auth_user_ip_t *ipdata;
     auth_user_t *auth_user;
@@ -312,7 +315,7 @@
     ipdata = (auth_user_ip_t *) auth_user->ip_list.head;
     while (ipdata) {
 	/* walk the ip list */
-	if (!memcmp(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr))) {
+	if (ipdata->ipaddr.s_addr == ipaddr.s_addr) {
 	    authenticateAuthUserRemoveIpEntry(auth_user, ipdata);
 	    return;
 	}
@@ -431,7 +434,7 @@
  * the authenticateStart routine for rv==AUTH_ACL_HELPER
  */
 auth_acl_t
-authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr)
+authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr)
 {
     const char *proxy_auth;
     assert(headertype != 0);
@@ -497,8 +500,8 @@
 	if (proxy_auth && !request->auth_user_request && conn && conn->auth_user_request) {
 	    int id = authenticateAuthSchemeId(proxy_auth) + 1;
 	    if (!conn->auth_user_request->auth_user || conn->auth_user_request->auth_user->auth_module != id) {
-		debug(29, 1) ("authenticateAuthenticate: Unexpected change of authentication scheme from '%s' to '%s'", /* (client %s)\n",*/
-		    authscheme_list[conn->auth_user_request->auth_user->auth_module - 1].typestr, proxy_auth/*, inet_ntoa(src_addr)*/); /* XXX husni */
+		debug(29, 1) ("authenticateAuthenticate: Unexpected change of authentication scheme from '%s' to '%s' (client %s)\n",
+		    authscheme_list[conn->auth_user_request->auth_user->auth_module - 1].typestr, proxy_auth, inet_ntoa(src_addr));
 		authenticateAuthUserRequestUnlock(conn->auth_user_request);
 		conn->auth_user_request = NULL;
 		conn->auth_type = AUTH_UNKNOWN;
@@ -599,7 +602,7 @@
 }
 
 auth_acl_t
-authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr)
+authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr)
 {
     /* If we have already been called, return the cached value */
     auth_user_request_t *t = authTryGetUser(auth_user_request, conn, request);
